<script lang="ts" setup>
import { useReceiptStore } from '@/stores/receipt'
import { nextTick, ref, watch } from 'vue'
import type { VSheet } from 'vuetify/components'

const receiptStore = useReceiptStore()

const div = ref<HTMLElement | null>(null)

const scrollToBottom = () => {
  div.value?.scrollTo({ top: div.value.scrollHeight, behavior: 'smooth' })
}

watch(receiptStore.receiptItems, () => {
  nextTick(() => {
    scrollToBottom()
  })
})

const props = withDefaults(defineProps<{ editable: boolean }>(), { editable: true })
</script>
<template>
  <div class="overflow-auto" ref="div">
    <v-sheet max-width="600" min-width="300" height="300" elevation="3">
      <v-table class="text-left">
        <thead>
          <tr>
            <th>#</th>
            <th>ชื่อ</th>
            <th>ราคา</th>
            <th>จำนวน</th>
            <th>ราคารวม</th>
            <th></th>
          </tr>
        </thead>
        <tbody>
          <tr v-for="(item, index) of receiptStore.receiptItems" :key="index">
            <td>{{ index + 1 }}</td>
            <td>{{ item.name }}</td>
            <td>{{ item.price }}</td>
            <td>
              <v-btn
                v-if="props.editable ? true : false"
                icon="mdi-minus"
                density="compact"
                @click="
                  () => {
                    receiptStore.decUnitOfReceiptItem(item)
                  }
                "
              ></v-btn
              ><span class="pl-3 pr-3">{{ item.unit }}</span>
              <v-btn
                v-if="props.editable ? true : false"
                icon="mdi-plus"
                density="compact"
                @click="
                  () => {
                    receiptStore.incUnitOfReceiptItem(item)
                  }
                "
              ></v-btn>
            </td>
            <td>{{ item.price * item.unit }}</td>
            <td>
              <v-btn
                v-if="props.editable ? true : false"
                density="compact"
                icon="mdi-delete"
                color="red"
                @click="
                  () => {
                    receiptStore.removeItem(item)
                  }
                "
              ></v-btn>
            </td>
          </tr>
        </tbody>
      </v-table>
    </v-sheet>
  </div>
</template>
